<template>
  <div class="sw-gs-layer-product-card-horizontal-wrapper">
    <SfProductCardHorizontal
      :title="name"
      :link="''"
      :image="imageUrl"
      :special-price="formatPrice(specialPrice)"
      :regular-price="formatPrice(regularPrice)"
      :image-width="60"
      :image-height="70"
      class="sw-gs-layer-product-card-horizontal"
      :wishlistIcon="false"
    >
      <template #title>
        <a href="" class="sf-link sf-product-card-horizontal__link">
          <h3 class="sf-product-card-horizontal__title">
            {{ name }}
          </h3>
        </a>
        <SfLoader class="sw-gs-remove-btn-loading" :loading="isLoading">
          <SfButton class="sf-button--pure sf-bar__icon" aria-label="remove" type="button" @click="handleRemoveFromGuideList">
            <SfIcon icon="cross" size="10px"/>
          </SfButton>
        </SfLoader>
      </template>
      <template #description><span></span></template>
      <template #configuration><span></span></template>
      <template #actions><span></span></template>
      <template #add-to-cart><span></span></template>
    </SfProductCardHorizontal>
    <div class="sw-gs-layer-product-actions-container">
      <div class="sw-gs-layer-product-reactions">
        <SwButton class="sw-gs-layer-product-reaction is-action-likes color-transparent" :title="$t('Likes')">
          <SwGsIconThumbsUpSmall class="color-secondary-primary size-sm"/>
          <SfLoader :loading="likeAndDislikeLoading" class="sw-gs-layer-product-actions-loader">
            <span class="sw-gs-layer-product-action-additional-infos">
              {{ allProductLikesCount }}
            </span>
          </SfLoader>
        </SwButton>

        <SwButton class="sw-gs-layer-product-reaction is-action-dislikes color-transparent" :title="$t('Dislikes')">
          <SwGsIconThumbsDownSmall class="color-secondary-primary size-sm"/>
          <SfLoader :loading="likeAndDislikeLoading" class="sw-gs-layer-product-actions-loader">
            <span class="sw-gs-layer-product-action-additional-infos">
              {{ allProductDislikesCount }}
            </span>
          </SfLoader>
        </SwButton>
      </div>
      <SwButton
                type="button" 
                class="sw-gs-layer-product-action is-action-detail color-transparent"
                :title="$t('Go to product detail page')"
                @click="goToDetailClick()">
        {{ $t('Go to product') }}
        <SwGsIconLongArrowRight class="color-secondary-primary size-xs"/>
      </SwButton>
    </div>
  </div>
</template>

<script lang="ts">
  import { SfProductCardHorizontal, SfButton, SfIcon, SfLoader } from "@storefront-ui/vue"
  import {
    getProductThumbnailUrl,
    getProductTierPrices,
    getProductName,
    getProductCalculatedPrice,
    getProductCalculatedListingPrice,
    getProductPriceDiscount,
  } from "@shopware-pwa/helpers"
  import getResizedImage from "@/helpers/images/getResizedImage.js";
  import {toRefs, computed, ref, onMounted} from "@vue/composition-api";
  import { usePriceFilter } from "../../logic/composables/usePriceFilter";
  import SwImage from "@/components/atoms/SwImage.vue";
  import SwGsLayerProductActions from "./SwGsLayerProductActions.vue";
  import { useLikeList } from "../../logic/composables/useLikeList";
  import { SwGsIconThumbsUpSmall, SwGsIconThumbsDownSmall, SwGsIconLongArrowRight } from "../icons";
  import SwButton from "@/components/atoms/SwButton.vue";
  import { useInstantListing } from "../../logic/composables/useInstantListing";
  import { useDynamicPage } from "../../logic/composables/useDynamicPage";

  export default {
    name: "SwGsLayerProductCardHorizontal",
    components: {
      SfProductCardHorizontal,
      SfButton,
      SwImage,
      SwButton,
      SfIcon,
      SfLoader,
      SwGsLayerProductActions,
      SwGsIconThumbsUpSmall,
      SwGsIconThumbsDownSmall,
      SwGsIconLongArrowRight
    },
    setup(props, {}) {
      const { formatPrice } = usePriceFilter();
      const { product } = toRefs(props)
      const {
        loadAllProductLikesAndDislikes,
        allProductLikesCount,
        allProductDislikesCount,
        guideLike,
        productOnGuideList,
        initLikeListForProductWidget
      } = useLikeList(product.value);

      const {
        isInstantListingModalOpen,
        removeProductForGuidedProductListing,
      } = useInstantListing();
      const {openDynamicPage} = useDynamicPage();

      const likeAndDislikeLoading = ref(false);
      const isLoading = ref(false);

      onMounted(async () => {
        await loadAllProductLikesAndDislikes();
      })

      const goToDetailClick = () => {
        isInstantListingModalOpen.value = false;

        openDynamicPage({
          type: 'product',
          opened: true,
          productId: product.value.id
        })
      }

      const handleRemoveFromGuideList = async () => {
        if (isLoading.value) return;
        isLoading.value = true;
        await removeProductForGuidedProductListing(product.value);
        isLoading.value = false;
      }

      const name = computed(() =>
        getProductName({product: product.value})
      )

      const imageUrl = computed(() =>
        getResizedImage(getProductThumbnailUrl(product.value), {
          width: 60,
          height: 70,
          quality: 100
        })
      )

      const tierPrices = computed(() =>
        getProductTierPrices(product.value)
      )

      const specialPrice = computed(() =>
        tierPrices.value.length
          ? undefined
          : getProductPriceDiscount(product.value) &&
          getProductCalculatedPrice(product.value)
      )

      const regularPrice = computed(() =>
        (tierPrices.value.length &&
          tierPrices.value[0] &&
          tierPrices.value[0].unitPrice) ||
        getProductCalculatedListingPrice(product.value)
      )

      return {
        name,
        imageUrl,
        tierPrices,
        specialPrice,
        regularPrice,
        formatPrice,
        loadAllProductLikesAndDislikes,
        removeProductForGuidedProductListing,
        allProductLikesCount,
        allProductDislikesCount,
        guideLike,
        handleRemoveFromGuideList,
        productOnGuideList,
        goToDetailClick,
        initLikeListForProductWidget,
        likeAndDislikeLoading,
        isLoading
      }
    },
    props: {
      product: {
        type: Object,
        default: () => ({}),
      },
    }
  }
</script>

<style lang="scss" scoped>
  .sw-gs-layer-product-card-horizontal-wrapper {
    padding: var(--spacer-sm) 0;
    border-bottom: 1px solid var(--_c-gray-accent);
    &:hover {
      box-shadow: var(--product-card-horizontal-box-shadow, 0px 4px 11px rgba(29, 31, 34, 0.1));
    }
  }

  .sw-gs-layer-product-card-horizontal {
    width: 100%;
    padding: var(--spacer-xs);
    &:hover {
      box-shadow: none;
    }
  }
  .sw-gs-remove-btn-loading {
    position: absolute;
    top: 0;
    right: 0;
    width: 24px;
    height: 24px;
  } 

  .sw-gs-layer-product-actions-container {
    display: flex;
    justify-content: space-between;
    padding: var(--spacer-xs);
  }
  .sw-gs-layer-product-reactions {
    display: flex;
    align-items: center;
    width: 84px;
    justify-content: space-between;
  }
  .sw-gs-layer-product-reaction {
    padding: 0;
  }
  .sw-gs-layer-product-action {
    background-color: var(--c-light);
    --button-padding: 12px;
    color: var(--c-text);
    text-transform: none;
    .sw-gs-icon {
      margin-left: 8px;
    }
  }

  .is-action-likes {
    --icon-color: var(--c-success);

    .sw-gs-layer-product-action-additional-infos {
      color: var(--c-success);
      font-weight: 700;
    }
  }

  .is-action-dislikes {
    --icon-color: var(--c-danger);

    .sw-gs-layer-product-action-additional-infos {
      color: var(--c-danger);
      font-weight: 700;
    }
  }

  ::v-deep {
    .sf-product-card-horizontal__main {
      flex-direction: column;
      overflow: hidden;
      justify-content: center;
      position: relative;
    }

    .sf-product-card-horizontal__image-wrapper {
      --product-card-horizontal-image-width: 84px;
      height: 111px;
      border: 1px solid var(--_c-gray-accent);
      .sf-product-card-horizontal__link--image, .sf-product-card-horizontal__image, .sf-image {
        width: 100%;
        height: 100%;
      }
      .sf-image {
        object-fit: contain;
      }
    }

    .sf-product-card__image-wrapper {
      overflow: hidden;
    }

    .sf-image--wrapper {
      display: block;
      height: 70px;
    }

    .sf-product-card__link {
      cursor: auto;
    }

    .sf-product-card-horizontal__link {
      pointer-events: none; // disable link
      cursor: default;
    }

    .sf-product-card-horizontal__details {
      .sf-button {
        background: var(--c-light);
        padding: 7px;
        .sf-icon {
          width: 10px;
          svg {
            stroke-width: 2;
            stroke: black;
          }
        }
      }
    }

    .sf-button:hover {
      --button-box-shadow-opacity: 0;
    }

    .sf-product-card-horizontal__configuration {
      margin: 0;
    }

    .sf-product-card-horizontal__title,
    .sf-price__regular,
    .sf-price__special {
      font-size: var(--font-size--sm);
    }

    .sf-price__regular,
    .sf-price__special {
      font-weight: 700;
    }

    .sf-product-card-horizontal__title {
      font-weight: 600;
    }

    .sf-product-card-horizontal__actions-wrapper {
      align-items: flex-start;
      flex: 0;
    }

    .sf-product-card-horizontal__actions {
      width: 100%;
      margin-top: var(--spacer-xs);
    }
  }
</style>
